package com.zksy.web.controller.basicData;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.TypeReference;
import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmEnterpriseTalentStatistics;
import com.zksy.system.basicData.domain.CrmEnterpriseTaxClassificationInfo;
import com.zksy.system.basicData.service.CrmEnterpriseTalentStatisticsService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.MergeReadsExcelUtil;
import com.zksy.utils.SearchUtil;
import com.zksy.common.annotation.Log;
import com.zksy.common.enums.BusinessType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;
import java.util.Map;

/**
 * 企业人才信息统计Controller
 *
 * @author sy
 * @date 2024-09-27
 */
@RestController
@RequestMapping("/crmEnterpriseTalentStatistics")
@Api(tags = "企业人才信息统计", description = "企业人才信息统计desc")
public class CrmEnterpriseTalentStatisticsController extends BaseController{

    @Autowired
    private CrmEnterpriseTalentStatisticsService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "企业人才信息统计搜索getById")
    public CrmEnterpriseTalentStatistics getById(@PathVariable String borrowId) {
        return service.getById(borrowId);
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "企业人才信息统计分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "企业人才信息统计查询所有")
    public List<CrmEnterpriseTalentStatistics> getList(String conditionJson) throws Exception {
        return service.list(SearchUtil.parseWhereSql(conditionJson));
    }

    /**
     * 新增企业人才信息统计
     */
    @PostMapping("/save")
    @ApiOperation(value = "企业人才信息统计新增")
    @Log(title = "新增企业人才信息统计", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmEnterpriseTalentStatistics crmEnterpriseTalentStatistics) {
        return service.save(crmEnterpriseTalentStatistics);
    }

    /**
     * 修改企业人才信息统计
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "企业人才信息统计修改")
    @Log(title = "修改企业人才信息统计", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmEnterpriseTalentStatistics crmEnterpriseTalentStatistics) {
        return service.updateById(crmEnterpriseTalentStatistics);
    }

    /**
     * 导入企业人才信息统计
     */
    @ApiOperation("企业人才信息统计导入")
    @Log(title = "企业人才信息统计", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            //List<CrmEnterpriseTalentStatistics> crmEnterpriseTalentStatisticsAll = service.list();
            //excel单元格合并导入
            //参数：文件， 表头列数， 是否读取序号0-读取、1-不读取， 表头占的行数下标从0开始的
            List<Map<String,String>> list = MergeReadsExcelUtil.readExcelToObj(file, CrmEnterpriseTalentStatistics.class.getDeclaredFields().length - 2,1,2,CrmEnterpriseTalentStatistics.class);
            List<CrmEnterpriseTalentStatistics> crmEnterpriseTalentStatistics= JSON.parseObject(JSON.toJSONString(list), new TypeReference<List<CrmEnterpriseTalentStatistics>>() {});
            /*if(crmEnterpriseTalentStatisticsAll != null && crmEnterpriseTalentStatisticsAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }*/
            if(list.size() > 0){
                service.saveBatch(crmEnterpriseTalentStatistics);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("企业人才信息统计导出")
    @Log(title = "企业人才信息统计", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmEnterpriseTalentStatistics> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"企业人才信息统计",wrapperList,CrmEnterpriseTalentStatistics.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "企业人才信息统计", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除企业人才信息统计", notes = "删除企业人才信息统计")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"企业人才信息统计模板");
    }
}

